/*
 * Copyright (c) 2016 Synopsys, Inc.
 *
 * Synopsys DP TX Linux Software Driver and documentation (hereinafter,
 * "Software") is an Unsupported proprietary work of Synopsys, Inc. unless
 * otherwise expressly agreed to in writing between Synopsys and you.
 *
 * The Software IS NOT an item of Licensed Software or Licensed Product under
 * any End User Software License Agreement or Agreement for Licensed Product
 * with Synopsys or any supplement thereto. You are permitted to use and
 * redistribute this Software in source and binary forms, with or without
 * modification, provided that redistributions of source code must retain this
 * notice. You may not view, use, disclose, copy or distribute this file or
 * any information contained herein except pursuant to this license grant from
 * Synopsys. If you do not agree with this notice, including the disclaimer
 * below, then you are not authorized to use the Software.
 *
 * THIS SOFTWARE IS BEING DISTRIBUTED BY SYNOPSYS SOLELY ON AN "AS IS" BASIS
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE HEREBY DISCLAIMED. IN NO EVENT SHALL SYNOPSYS BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
 * DAMAGE.
 */

#ifndef __XDX_DP_CORE_H__
#define __XDX_DP_CORE_H__
#include "xdx_dp.h"

void dptx_soft_reset_all(struct dptx *dptx);
void dptx_phy_soft_reset(struct dptx *dptx);
void dptx_core_init_phy(struct dptx *dptx);
bool dptx_check_dptx_id(struct dptx *dptx);
int dptx_core_deinit(struct dptx *dptx);
unsigned int dptx_phy_get_lanes(struct dptx *dptx);
unsigned int dwc_phy_get_rate(struct dptx *dptx);

void dptx_init_hwparams(struct dptx *dptx);
void dptx_hpd_intr_dis(struct dptx *dptx);
void dptx_hpd_intr_en(struct dptx *dptx);
void dptx_global_intr_dis(struct dptx *dptx);
void dptx_global_intr_en(struct dptx *dptx);
bool dptx_sink_enabled_ssc(struct dptx *dptx);
int dptx_core_init(struct dptx *dptx);

void dptx_phy_set_vswing(struct dptx *dptx,
			unsigned int lane,
			unsigned int level);
void dptx_phy_set_lanes(struct dptx *dptx, unsigned int lanes);
void dptx_phy_set_powerdown(struct dptx *dptx, unsigned int lanes);
void dptx_phy_set_rate(struct dptx *dptx, unsigned int rate);
void dptx_phy_set_pattern(struct dptx *dptx,
			unsigned int pattern);
void dptx_phy_enable_xmit(struct dptx *dptx, unsigned int lanes, bool enable);
int dptx_phy_rate_to_bw(unsigned int rate);
int dptx_bw_to_phy_rate(unsigned int bw);
void dptx_soft_reset(struct dptx *dptx, u32 bits);
int dptx_phy_wait_busy(struct dptx *dptx, unsigned int lanes);
void xdx_tile_init(struct dptx *dptx);
void dptx_phy_set_pre_emphasis(struct dptx *dptx,
			unsigned int lane,
			unsigned int level);
int dptx_core_program_ssc(struct dptx *dptx, bool sink_ssc);
void dptx_enable_ssc(struct dptx *dptx);
void dptx_interrupt_en(struct dptx *dptx);
#endif
