/*-*- linux-c -*-
 *  linux/drivers/video/i810_accel.c -- Hardware Acceleration
 *
 *      Copyright (C) 2001 Antonino Daplas<adaplas@pol.net>
 *      All Rights Reserved      
 *
 *  This file is subject to the terms and conditions of the GNU General Public
 *  License. See the file COPYING in the main directory of this archive for
 *  more details.
 */
#ifndef __XDX_AUX__
#define __XDX_AUX__
#include <linux/kernel.h>
#include "xdx_dp.h"

int xdx_dp_aux_init(struct dp_dev *dp);

int __dptx_read_bytes_from_dpcd(struct dptx *dptx, u32 reg_addr, u8 *bytes, u32 len);
int __dptx_write_bytes_to_dpcd(struct dptx *dptx, u32 reg_addr, u8 *bytes, u32 len);
int dptx_aux_rw_bytes(struct dptx *dptx, bool rw, bool i2c, u32 addr, u8 *bytes, unsigned int len);
int dptx_i2c_address_only(struct dptx *dptx, unsigned int device_addr);
int dptx_read_bytes_from_i2c(struct dptx *dptx, u32 device_addr, u8 *bytes, u32 len);
int dptx_write_bytes_to_i2c(struct dptx *dptx, u32 device_addr, u8 *bytes, u32 len);
int __dptx_read_dpcd(struct dptx *dptx, u32 addr, u8 *byte);
int __dptx_write_dpcd(struct dptx *dptx, u32 addr, u8 byte);

#endif
