/*-*- linux-c -*-
 *  linux/drivers/video/i810_accel.c -- Hardware Acceleration
 *
 *      Copyright (C) 2001 Antonino Daplas<adaplas@pol.net>
 *      All Rights Reserved      
 *
 *  This file is subject to the terms and conditions of the GNU General Public
 *  License. See the file COPYING in the main directory of this archive for
 *  more details.
 */
 #ifndef __XDX_DP_ACCEL__
 #define __XDX_DP_ACCEL__
#include <linux/kernel.h>
#include "xdx_dp.h"

u32 dptx_readl(struct dptx *dptx, u32 offset);
void dptx_writel(struct dptx *dptx, u32 offset, u32 value);

int dptx_read_dpcd(struct dptx *dptx, u32 addr, u8 *byteptr);
int dptx_write_dpcd(struct dptx *dptx, u32 addr, u8 byte);

u32 dptx_tilereadl(struct dptx *dptx, u32 offset);
void dptx_tilewritel(struct dptx *dptx, u32 offset, u32 data);

u32 dptx_pcs_readl(struct dptx *dptx, u32 offset);
void dptx_pcs_writel(struct dptx *dptx, u32 offset, u16 data);

int dptx_write_bytes_to_dpcd(struct dptx *dptx, unsigned int reg_addr, \
									u8 *bytes, u32 len);
int dptx_read_bytes_from_dpcd(struct dptx *dptx, unsigned int reg_addr, \
									u8 *bytes, u32 len);
void xdx_dp_h2a_doorbell_w(struct dptx *dptx, u64 value);
u32 xdx_dp_h2a_doorbell_r(struct dptx *dptx);
#endif
