/* SPDX-License-Identifier: GPL-2.0 */
/*
 * Copyright (c) 2010 Synopsys, Inc. and/or its affiliates
 * Synopsys DesignWare HDMIQP TX controller driver
 */

#ifndef HALFRAMECOMPOSERPACKETS_H_
#define HALFRAMECOMPOSERPACKETS_H_

#include "xdx_hdmi.h"

#define MANUAL			0
#define AUTO			1

#define CHECKSUM_OFFSET		4
#define PB0_OFFSET		4
#define PB1_OFFSET		5
#define PB9_OFFSET		13
#define PB25_OFFSET		29

enum pkt_type {
	NULL_PKT = 0,
	ACR,
	AUDS,
	GCP,
	ACP,
	ISRC1,
	ISRC2,
	GMD,
	AMD,
	VTEM,
	CVTEM,
	EXTMEM,
	VSI,
	AVI,
	SPDI,
	AUDI,
	MSI,
	DRMI,
	GHDMI1,
	GHDMI2,
};

void fc_packets_GCP_enable(struct           hdmi_dev *dev);

void fc_packets_enable(struct hdmi_dev *dev, enum pkt_type type, u8 mode);

void fc_packets_disable(struct hdmi_dev *dev, enum pkt_type type);

void fc_packets_disable_all(struct hdmi_dev *dev);

void fc_spdi_config(struct hdmi_dev *dev);
void fc_gamut_config(struct hdmi_dev *dev, const u8 *gbdContent, u8 length);

u8 infoframe_checksum(u8 *buff);
int packets_Configure(struct hdmi_dev *dev);
void packets_AvMute(struct hdmi_dev *dev, u8 enable);

#endif	/* HALFRAMECOMPOSERPACKETS_H_ */
