// SPDX-License-Identifier: GPL-2.0
/*
 * Copyright (c) 2010 Synopsys, Inc. and/or its affiliates
 * Synopsys DesignWare HDMIQP TX controller driver
 */

#include "xdx_hdmi_accel.h"
#include "xdx_hdmi.h"
#include "xdx_hdmi_reg.h"
#include "fc_packets.h"

// Source Product Descriptor
void fc_spdi_config(struct hdmi_dev *dev)
{
	u8 buff[32] = {0};	// 8 registers of 32bits
	u8 i, *ptr;

	buff[0] = 0x83;
	buff[1] = 1;
	buff[2] = 25;

	// PB1 - PB8
	ptr = &buff[PB1_OFFSET];
	memcpy(ptr, "SYNOPSYS", 8);

	// PB9 - PB24
	ptr = &buff[PB9_OFFSET];
	*ptr = dev_read_mask(dev, CORE_ID, 0xFF000000);
	ptr++;
	*ptr = dev_read_mask(dev, CORE_ID, 0x00FF0000);
	ptr++;
	*ptr = dev_read_mask(dev, CORE_ID, 0x0000FF00);
	ptr++;
	*ptr = dev_read_mask(dev, CORE_ID, 0x000000FF);
	ptr++;
	*ptr = '-';
	ptr++;
	*ptr = dev_read_mask(dev, VER_TYPE, 0xFF000000);
	ptr++;
	*ptr = dev_read_mask(dev, VER_TYPE, 0x00FF0000);
	ptr++;
	*ptr = dev_read_mask(dev, VER_TYPE, 0x0000FF00);
	ptr++;
	*ptr = dev_read_mask(dev, VER_TYPE, 0x000000FF);
	ptr++;
	*ptr = '-';
	ptr++;
	*ptr = dev_read_mask(dev, VER_NUMBER, 0xFF000000);
	ptr++;
	*ptr = dev_read_mask(dev, VER_NUMBER, 0x00FF0000);
	ptr++;
	*ptr = dev_read_mask(dev, VER_NUMBER, 0x0000FF00);
	ptr++;
	*ptr = dev_read_mask(dev, VER_NUMBER, 0x000000FF);

	// PB25
	buff[PB25_OFFSET] = 0x9;

	// PB0
	buff[CHECKSUM_OFFSET] = infoframe_checksum(buff);

	dev_write_mask(dev, PKT_SPDI_CONTENTS0, 0x00FFFF00, *((u32*)&buff[0]));
	for (i = 0; i <= (PKT_SPDI_CONTENTS7 - PKT_SPDI_CONTENTS1); i += 4)
		xdx_hdmicore_write(dev, PKT_SPDI_CONTENTS1 + i, *((u32*)&buff[PB0_OFFSET + i]));
}
