// SPDX-License-Identifier: GPL-2.0
/*
 * Copyright (c) 2010 Synopsys, Inc. and/or its affiliates
 * Synopsys DesignWare HDMIQP TX controller driver
 */

#include "xdx_hdmi_accel.h"
#include "fc_vsi.h"
#include "fc_packets.h"
#include "xdx_hdmi_reg.h"

void fc_vsi_config(struct hdmi_dev *dev, u8 *payload, u8 length)
{
	u8 buff[32] = {0};	// 8 registers of 32bits
	u8 i, *ptr;

	buff[0] = 0x81;
	buff[1] = 0x01;
	buff[2] = (4 + length);	// Checksum + IEEE Identifier + length

	// PB1, PB2 and PB3
	ptr = &buff[PB1_OFFSET];
	*((uint32_t *)ptr) = (uint32_t)HDMI_LICENSING_LLC_OUI;

	// PB4++
	ptr += 3;
	if (payload && length)
		memcpy(ptr, payload, length);

	// PB0
	buff[CHECKSUM_OFFSET] = infoframe_checksum(buff);

	dev_write_mask(dev, PKT_VSI_CONTENTS0, 0x00FFFF00, *((u32*)&buff[0]));
	for (i = 0; i <= (PKT_VSI_CONTENTS7 - PKT_VSI_CONTENTS1); i += 4)
		xdx_hdmicore_write(dev, PKT_VSI_CONTENTS1 + i, *((u32*)&buff[CHECKSUM_OFFSET + i]));
}
