#ifndef _PG_PHYCONFIG_PAR_
#define _PG_PHYCONFIG_PAR_
#include <linux/kernel.h>
#include "xdx_hdmi.h"
#include "xdx_device.h"
typedef struct XDX_PHY_CONFIG_VALUE{
	uint8_t       mpll_multiplier;
	uint16_t      rx_vco_ld_val;
	uint8_t       ref_range;
	uint8_t       ref_clk_mpll_div2_en;
	uint8_t       bg_en;
	uint8_t       mpll_div10_clk_en;
	uint8_t       rx_vref_ctrl;
	uint8_t       mpll_ssc_freq_cnt_peak;
	uint8_t       mpll_tx_clk_div;
	uint8_t       mpll_pmix_en;
	uint8_t       mpll_ssc_en;
	uint8_t       bs_tx_lowswing;
	uint8_t       rx_ref_ld_val;
	uint8_t       mpll_div8_clk_en;
	uint16_t      mpll_bandwidth;
	uint16_t      mpll_fracn_ctrl;
	uint8_t       mpll_ssc_range;
	uint8_t       bs_rx_bigswing;
	uint8_t       mpll_ssc_clk_sel;
	uint16_t      mpll_ssc_freq_cnt_init;
	uint8_t       mpll_word_div2_en;
	uint8_t       mpllb_sel;
	uint8_t       mpll_div_multiplier;
	uint8_t       mpll_ana_hdmi_div;
	uint8_t       mpll_div_clk_en;
	uint8_t       tx_vboost_lvl;
	uint8_t       ref_clk_div2_en;
	uint8_t       bs_rx_level;
	uint8_t       mpll_ana_hdmi_div_clk_en;
	uint8_t       tx_mpllb_sel;
	uint8_t       tx_iboost_lvl;
	uint8_t       tx_rate;
	uint8_t       tx_eq_pre;
	uint8_t       rx_adapt_afe_en;
	uint8_t       rx_los_lfps_en; 
	uint8_t       rx_eq_ctle_boost;
	uint8_t       tx_term_ctrl;
    uint8_t       rx_los_threshold;
	uint32_t      rx_baud_rate;
	uint8_t       tx_width;
	uint32_t      tx_baud_rate;
	uint8_t       rx_eq_dfe_tap1;
	uint64_t      mpll_vco_frequency;
	uint8_t       rx_align_en;
	uint8_t       tx_vboost_en;
	uint8_t       rx_term_acdc;
	uint8_t       rx_adapt_dfe_en;
	uint8_t       rx_eq_att_lvl;
	uint8_t       rx_width;
	uint8_t       tx_eq_main;
	uint8_t       tx_eq_post;
	uint8_t       rx_eq_delta_iq;
	uint8_t       rx_cdr_vco_lowfreq;
	uint8_t       rx_cdr_ssc_en;
	uint8_t       rx_eq_afe_gain;
	uint8_t       rx_rate;
	uint8_t       rx_term_ctrl;
}PHY_CONFIG_VALUE;

#define  ALL_HDMIDP_PHY_IF_CLR  0xa4
#define  ALL_HDMIDP_PHY_IF_RAW  0xa8
#define  ALL_HDMI_PHY_CTRL      0x0
#define  ALL_HDMI_PCS_CTRL      0x8

int GetConfigValue(PHY_CONFIG_VALUE *configvalue, uint8_t w,uint8_t d,uint8_t clk,uint16_t rate,uint8_t protocol);
void hdmiconfigmessage( PHY_CONFIG_VALUE *configvalue);
int xdx_hdmi_phy_startup(struct hdmi_dev *hdmi);
int xdx_phy_power_down(struct hdmi_dev *hdmi);
int xdx_phy_power_down_sink(struct hdmi_dev *hdmi);
int xdx_phy_power_up(struct hdmi_dev *hdmi);

#endif
