#include <linux/interrupt.h>
#include <linux/delay.h>
#include <linux/moduleparam.h>
#include <linux/version.h>
#include <linux/dma-mapping.h>

#include "sysinfo.h"
//#include "pangu_drv.h"
#include "xdx_dma.h"
#include "B0_HalVdma.h"

#include "pangu.h"
#include "virt-dma.h"

#include "pvrmodule.h"
//#include <linux/platform_device.h>
#include <linux/dma-mapping.h>
#include <linux/init.h>
#include <linux/module.h>
#include <linux/mm.h>
#include <linux/device.h>
#include <linux/dmaengine.h>
#include <linux/hardirq.h>
#include <linux/spinlock.h>
#include <linux/percpu.h>
#include <linux/rcupdate.h>
#include <linux/mutex.h>
#include <linux/jiffies.h>
#include <linux/rculist.h>
#include <linux/idr.h>
#include <linux/slab.h>
#include <linux/acpi.h>
#include <linux/acpi_dma.h>
#include <linux/of_dma.h>
#include <linux/mempool.h>
#include <linux/numa.h>
#include <linux/mod_devicetable.h>
#if (LINUX_VERSION_CODE >= KERNEL_VERSION(5, 11, 0))
#include <linux/dma-map-ops.h>
#endif

#if (LINUX_VERSION_CODE < KERNEL_VERSION(5, 11, 0))
#include <linux/gfp.h>
#endif
#include <linux/highmem.h>
#include "osfunc.h"
#include "hash.h"
#include "pvr_debug.h"
#include "dma_drv.h"
#include "generated/volcanic/dma_bridge/common_dma_bridge.h"

#include <linux/dmaengine.h>
#include <linux/delay.h>

#include "dma_debug.h"
#include "xdx_device.h"
#include "xdx_drv.h"
#include "syscommon.h"
#include "HalTDMA.h"

#define DMA_CHAN_CFG_SRC_WIDTH(x)	(((x) & 0x3) << 9)
#define DMA_CHAN_CFG_DST_WIDTH(x)	(DMA_CHAN_CFG_SRC_WIDTH(x) << 16)
#define VDMA_2D_64M  64*1024*1024 //64M
#define VDMA_2D_4M   4*1024*1024 //64B
#define VDMA_2D_2M   2*1024*1024 //32B
#define VDMA_2D_1M   1*1024*1024 //16B
#define VDMA_2D_512K 512*1024 //8B
#define TDMA_INT_ENABLE_MASK (1<<4)

#define DMA_SYNC_CHAN_NUM	(2)
#define VDMA_ADDR_OFFSET    (0x200000)

#define B0_DESCS_SIZE PAGE_SIZE*32
//static DEFINE_MUTEX(dma_list_mutex);
//static LIST_HEAD(dma_device_list);
static void __iomem *xdxdma_regsbase;
static void __iomem *xdxTdma_regsbase;
void __iomem *hostmisc_regsbase;

struct dma_chan_tbl_ent {
	struct dma_chan *chan;
};

#define DMA_CHAN_ID(_dma, _chan_num) ((((_dma)&0xf) << 8) | ((_chan_num) & 0xf))
#define DMA_DMA_NUM(_chan_id) (((_chan_id) >> 8) & 0xf)
#define DMA_CHAN_NUM(_chan_id) ((_chan_id) & 0xf)

#define XDXDMA_FLAG_VDMA (1 << 0)
#define XDXDMA_FLAG_TDMA (1 << 1)
#define XDXDMA_FLAG_A0 (1 << 2)
#define XDXDMA_FLAG_B0 (1 << 3)

#define XDXDMA_A0_VDMA_MASK (XDXDMA_FLAG_VDMA | XDXDMA_FLAG_A0)
#define XDXDMA_B0_VDMA_MASK (XDXDMA_FLAG_VDMA | XDXDMA_FLAG_B0)
#define XDXDMA_B0_TDMA_MASK (XDXDMA_FLAG_TDMA | XDXDMA_FLAG_B0)


static void xdx_set_burst_length(u32 *p_cfg, s8 src_burst, s8 dst_burst)
{

}

struct xdx_dma_pchan_cfg vdma_a0_pchans[] = {
//	{.chan_id = DMA_CHAN_ID(0, 0), .prio = 0},
//	{.chan_id = DMA_CHAN_ID(0, 1), .prio = 0},
	{.chan_id = DMA_CHAN_ID(0, 2), .prio = 0},
//	{.chan_id = DMA_CHAN_ID(0, 3), .prio = 0},
//	{.chan_id = DMA_CHAN_ID(1, 0), .prio = 0},
//	{.chan_id = DMA_CHAN_ID(1, 1), .prio = 0},
	{.chan_id = DMA_CHAN_ID(1, 2), .prio = 0},
//	{.chan_id = DMA_CHAN_ID(1, 3), .prio = 0},
};

u32 vdma_a0_pchans1[] = {
//	DMA_CHAN_ID(0, 0),
//	DMA_CHAN_ID(0, 1),
	DMA_CHAN_ID(0, 2),
//	DMA_CHAN_ID(0, 3),
//	DMA_CHAN_ID(1, 0),
//	DMA_CHAN_ID(1, 1),
	DMA_CHAN_ID(1, 2),
//	DMA_CHAN_ID(1, 3),
};

struct xdx_dma_vchan_cfg vdma_a0_vchans[] = {
	{
		.dev_id = 0,
		.prio = -1,
		.num_pchan = ARRAY_SIZE(vdma_a0_pchans1),
		.pchans = vdma_a0_pchans1,
	},
};

static struct dma_slave_map xdx_vdmaa0_map[] = {
	{.devname = "xdx_vdma", .slave = "xdx_dma",.param = "xdx_vdma"},
};

static struct xdx_dma_drv_cfg xdxvdma_a0 = {
	.set_burst_length = xdx_set_burst_length,
	.src_addr_widths   = BIT(DMA_SLAVE_BUSWIDTH_1_BYTE) |
				BIT(DMA_SLAVE_BUSWIDTH_2_BYTES) |
				BIT(DMA_SLAVE_BUSWIDTH_4_BYTES),
	.dst_addr_widths   = BIT(DMA_SLAVE_BUSWIDTH_1_BYTE) |
				BIT(DMA_SLAVE_BUSWIDTH_2_BYTES) |
				BIT(DMA_SLAVE_BUSWIDTH_4_BYTES),
	.flags = XDXDMA_FLAG_VDMA | XDXDMA_FLAG_A0,
	.num_vchan = ARRAY_SIZE(vdma_a0_vchans),
	.vchans = vdma_a0_vchans,
	.num_pchan = ARRAY_SIZE(vdma_a0_pchans),
	.pchans = vdma_a0_pchans,
	.fn_map = xdx_vdmaa0_map,
};

struct xdx_dma_pchan_cfg vdma_b0_pchans[] = {
//	{.chan_id = DMA_CHAN_ID(0, 0), .prio = 0,},
//	{.chan_id = DMA_CHAN_ID(0, 1), .prio = 0,},
	{.chan_id = DMA_CHAN_ID(0, 2), .prio = 0,},
//	{.chan_id = DMA_CHAN_ID(0, 3), .prio = 0,},
//	{.chan_id = DMA_CHAN_ID(1, 0), .prio = 0,},
//	{.chan_id = DMA_CHAN_ID(1, 1), .prio = 0,},
	{.chan_id = DMA_CHAN_ID(1, 2), .prio = 0,},
//	{.chan_id = DMA_CHAN_ID(1, 3), .prio = 0,},
};

const u32 vdma_b0_pchans1[] = {
//	DMA_CHAN_ID(0,0),
//	DMA_CHAN_ID(0,1),
	DMA_CHAN_ID(0,2),
//	DMA_CHAN_ID(0,3),
//	DMA_CHAN_ID(1,0),
//	DMA_CHAN_ID(1,1),
	DMA_CHAN_ID(1,2),
//	DMA_CHAN_ID(1,3),
};

struct xdx_dma_vchan_cfg vdma_b0_vchans[] = {
	{
		.dev_id = 0,
		.prio = -1,
		.num_pchan = ARRAY_SIZE(vdma_b0_pchans1),
		.pchans = vdma_b0_pchans1,
	},
};

static struct dma_slave_map xdx_vdmab0_map[] = {
	{.devname = "xdx_vdma", .slave = "xdx_dma",.param = "xdx_vdma"},
};

static struct xdx_dma_drv_cfg xdxvdma_b0 = {
	.set_burst_length = xdx_set_burst_length,
	.src_addr_widths   = BIT(DMA_SLAVE_BUSWIDTH_1_BYTE) |
				BIT(DMA_SLAVE_BUSWIDTH_2_BYTES) |
				BIT(DMA_SLAVE_BUSWIDTH_4_BYTES),
	.dst_addr_widths   = BIT(DMA_SLAVE_BUSWIDTH_1_BYTE) |
				BIT(DMA_SLAVE_BUSWIDTH_2_BYTES) |
				BIT(DMA_SLAVE_BUSWIDTH_4_BYTES),
	.flags = XDXDMA_FLAG_VDMA | XDXDMA_FLAG_B0,
	.num_vchan = ARRAY_SIZE(vdma_b0_vchans),
	.vchans = vdma_b0_vchans,
	.num_pchan = ARRAY_SIZE(vdma_b0_pchans),
	.pchans = vdma_b0_pchans,
	.fn_map = xdx_vdmab0_map,
};

struct xdx_dma_pchan_cfg tdma_b0_pchans[] = {
	{.chan_id = DMA_CHAN_ID(0, 0), .prio = 0,},
};

const u32 tdma_b0_pchans1[] = {
	DMA_CHAN_ID(0,0),
};

struct xdx_dma_vchan_cfg tdma_b0_vchans[] = {
	{
		.dev_id = 0,
		.prio = -1,
		.num_pchan = ARRAY_SIZE(tdma_b0_pchans1),
		.pchans = tdma_b0_pchans1,
	},
};

static struct dma_slave_map xdx_tdmab0_map[] = {
	{.devname = "xdx_tdma", .slave = "xdx_dma",.param = "xdx_tdma"},
};

static struct xdx_dma_drv_cfg xdxtdma_b0 = {
	.set_burst_length = xdx_set_burst_length,
	.src_addr_widths   = BIT(DMA_SLAVE_BUSWIDTH_1_BYTE) |
				BIT(DMA_SLAVE_BUSWIDTH_2_BYTES) |
				BIT(DMA_SLAVE_BUSWIDTH_4_BYTES),
	.dst_addr_widths   = BIT(DMA_SLAVE_BUSWIDTH_1_BYTE) |
				BIT(DMA_SLAVE_BUSWIDTH_2_BYTES) |
				BIT(DMA_SLAVE_BUSWIDTH_4_BYTES),
	.flags = XDXDMA_FLAG_TDMA | XDXDMA_FLAG_B0,
	.num_vchan = ARRAY_SIZE(tdma_b0_vchans),
	.vchans = tdma_b0_vchans,
	.num_pchan = ARRAY_SIZE(tdma_b0_pchans),
	.pchans = tdma_b0_pchans,
	.fn_map = xdx_tdmab0_map,
};

static struct platform_device_id xdx_platform_device_id_table[] = {
		{XDX_VDMA_A0_NAME,(kernel_ulong_t)&xdxvdma_a0},
		{XDX_VDMA_B0_NAME,(kernel_ulong_t)&xdxvdma_b0},
		{XDX_TDMA_B0_NAME,(kernel_ulong_t)&xdxtdma_b0},
		{}
};

#if defined(SUPPORT_DONT_SNOOP) || defined(__arm64__) || defined(__aarch64__)
static VDMA_CMD_Config_t xdx_dma_cmd_cfg[4] =
{
	{
		.OpCode = VDMA_DRV_OPCODE_COPY_DSRC_DDST,
		.IntrEn = 1,
		.PcieFuncNum = 0,
		.PcieDontSnoop = 1,
	},
	{
		.OpCode = VDMA_DRV_OPCODE_COPY_DSRC_LDST,
		.IntrEn = 1,
		.PcieFuncNum = 0,
		.PcieDontSnoop = 1,
	},
	{
		.OpCode = VDMA_DRV_OPCODE_COPY_LSRC_DDST,
		.IntrEn = 1,
		.PcieFuncNum = 0,
		.PcieDontSnoop = 1,
	},
	{
		.OpCode = VDMA_DRV_OPCODE_COPY_LSRC_LDST,
		.IntrEn = 1,
		.PcieFuncNum = 0,
		.PcieDontSnoop = 1,
	}
};
#else
static VDMA_CMD_Config_t xdx_dma_cmd_cfg[4] =
{
	{
		.OpCode = VDMA_DRV_OPCODE_COPY_DSRC_DDST,
		.IntrEn = 1,
		.PcieFuncNum = 0,
		.PcieDontSnoop = 0,
	},
	{
		.OpCode = VDMA_DRV_OPCODE_COPY_DSRC_LDST,
		.IntrEn = 1,
		.PcieFuncNum = 0,
		.PcieDontSnoop = 0,
	},
	{
		.OpCode = VDMA_DRV_OPCODE_COPY_LSRC_DDST,
		.IntrEn = 1,
		.PcieFuncNum = 0,
		.PcieDontSnoop = 0,
	},
	{
		.OpCode = VDMA_DRV_OPCODE_COPY_LSRC_LDST,
		.IntrEn = 1,
		.PcieFuncNum = 0,
		.PcieDontSnoop = 0,
	}
};
#endif

int dma_enable(void)
{
	pr_debug("Hello DMA ##############\n");
	return 0;
}
EXPORT_SYMBOL(dma_enable);

static struct device *chan2dev(struct dma_chan *chan)
{
	return &chan->dev->device;
}

struct xdx_dma_lli* alloc_lli(dma_addr_t *p_lli)
{
	struct page* pages;
	struct xdx_dma_lli* v_lli;

	pages = alloc_pages(GFP_KERNEL|__GFP_HIGHMEM, 0);
	*p_lli = page_to_phys(pages);
	v_lli = kmap(pages);

	/* kmap_atomic maps pages as cached so it's more quick to access by host cpu. *
	 * here (also pages are always 8 bytes aligned anyway) */
	return v_lli;
}

void free_lli(struct xdx_dma_lli *v_lli, dma_addr_t p_lli)
{
	//struct page* pages = kmap_to_page(v_lli);	//anyway is good for getting page from virtual address or physical address
	struct page* pages = pfn_to_page(__phys_to_pfn(p_lli));
	kunmap(pages);
	__free_pages(pages, 0);
}

static inline struct xdx_desc *
to_xdx_desc(struct dma_async_tx_descriptor *tx)
{
	return container_of(tx, struct xdx_desc, vd.tx);
}

static inline void xdx_dma_dump_lli(struct xdx_dma_lli *lli)
{
	// dev_dbg(chan2dev(&vchan->vc.chan),
	// 	"\t\tlen - 0x%08x next - 0x%08llx\n",
	// 	lli->len, (uint64_t)lli->v_lli_next);
	int i;
	pr_err("lli num %d\n", lli->desc_num);
	for(i=0; i < lli->desc_num - 1; i++)
	{
		pr_err("lli->xdma_desc[%d] addr %llx, TRAN LEN %d\n", i, (uint64_t)((uint64_t)lli->xdma_desc[i].nonend.DataBlkPtr_47_3 << 3), lli->xdma_desc[i].nonend.TransferLen);
	}

	pr_err("last lli->xdma_desc[%d] addr %llx, desNum %d, link end %x\n", lli->desc_num - 1, (uint64_t)((uint64_t)lli->xdma_desc[lli->desc_num - 1].end.NextDescPtr_47_3 << 3), lli->xdma_desc[lli->desc_num - 1].end.NextDescNum, (uint32_t)lli->xdma_desc[lli->desc_num - 1].end.LinkEnd);
	//VDMA_DRV_DumpVdmaDescData(&lli->xdma_desc);
}

static void *xdx_dma_lli_add(struct xdx_dma_lli *prev,
			struct xdx_dma_lli *next,
			dma_addr_t next_phy,
			struct xdx_desc *txd)
{
	if ((!prev && !txd) || !next)
		return NULL;

	next->xdma_desc[next->desc_num].all = 0;
	next->xdma_desc[next->desc_num].end.LinkEnd = 1;
	next->desc_num++;
	next->v_lli_next = NULL;
	if (!prev)
	{
		txd->p_lli = next_phy + offsetof(struct xdx_dma_lli, xdma_desc); //NOTICE LINKLIST NODE NEED OFFSET TO DESC
		txd->linklist_len = next->desc_num;
		txd->v_lli = next;
	}
	else
	{
		//DBG_ASSERT(TEST_ALIGNED(next_phy, VDMA_DRV_DESC_LINKPTR_ALIGN));	// Linklist use 16Byte Align! NOTICE LINKLIST NODE NEED OFFSET TO DESC
		VDMA_B0_GenEndVdmaDesc(next_phy + offsetof(struct xdx_dma_lli, xdma_desc), next->desc_num, 0, &(prev->xdma_desc[prev->desc_num-1]));
		prev->v_lli_next = next;
	}

	return next;
}

static void xdx_dma_free_desc(struct xdx_virt_dma_desc *vd)
{
	struct xdx_desc *txd = to_xdx_desc(&vd->tx);
	struct xdx_dma_dev *sdev = to_xdx_dma_dev(vd->tx.chan->device);
	struct xdx_dma_lli *v_lli, *v_next;
	dma_addr_t p_lli, p_next;

	if (unlikely(!txd))
		return;

	//pr_debug("xdx_dma_free_desc 0x%llx ...\n",(IMG_UINT64 *)vd);
	p_lli = txd->p_lli;
	v_lli = txd->v_lli;

	while (v_lli) {
		v_next = v_lli->v_lli_next;
		p_next = (dma_addr_t)(v_lli->xdma_desc[v_lli->desc_num-1].end.NextDescPtr_47_3) << VDMA_DRV_LINKLIST_SHIFT;

		free_lli(v_lli, p_lli - offsetof(struct xdx_dma_lli, xdma_desc));
		v_lli = v_next;
		p_lli = p_next;
	}
	kmem_cache_free(sdev->txpool, txd);
}


static uint32_t xdx_dma_get_command_tag(struct xdx_dma_dev *sdev, struct xdx_pchan **ppchan)
{
	uint32_t cmd_tag=0, i, cur_pID;
	struct xdx_pchan *pchan;

	cur_pID = (sdev->pchans[0].free_cmd > sdev->pchans[1].free_cmd) ? 0 : 1;

	for(i = 0; i < sdev->num_pchans; i++)
	{
		pchan = &(sdev->pchans[cur_pID]);

		spin_lock(&pchan->lock);
		if(pchan->DmaCmdPoolMask)
		{
			DBG_ASSERT(pchan->free_cmd > 0);

			cmd_tag = GetLeadOnefromU64(pchan->DmaCmdPoolMask);
			BIT_UNSET(pchan->DmaCmdPoolMask, cmd_tag);
			pchan->free_cmd--;
			pchan->submit_cmd++;
			spin_unlock(&pchan->lock);

			*ppchan	= pchan;
			break;
		}
		spin_unlock(&pchan->lock);
		cur_pID = (cur_pID + 1) & (sdev->num_pchans - 1); //round robbin next channel ID
	}

	return cmd_tag;
}

static inline void xdx_dma_release_command_tag(struct xdx_pchan *pchan, int cmd_tag)
{
	DBG_ASSERT(pchan->free_cmd < CMD_MAX);
	DBG_ASSERT(!BIT_ISSET(pchan->DmaCmdPoolMask, cmd_tag));
	DBG_ASSERT(pchan->submit_cmd > 0);
	BIT_SET(pchan->DmaCmdPoolMask, cmd_tag);
	pchan->free_cmd++;
	pchan->submit_cmd--;
#ifdef DEBUG_DMA
	pr_debug("ISR pchan %d free cmd %d, submit cmd %d, pool mask %llx...\n",
				pchan->idx, pchan->free_cmd, pchan->submit_cmd, pchan->DmaCmdPoolMask);
#endif
}

static uint32_t xdx_Tdma_get_command_tag(struct xdx_dma_dev *sdev, struct xdx_pchan **ppchan)
{
	uint32_t cmd_tag = 0, i;
	struct xdx_pchan *pchan;

	for (i = 0; i < sdev->num_pchans; i++) {
		pchan = &(sdev->pchans[0]);
		//sdev->cur_pID.counter = 0;
		if (pchan->DmaCmdPoolMask) {
			DBG_ASSERT(pchan->free_cmd > 0);

			spin_lock(&pchan->lock);
			cmd_tag = GetLeadOnefromU64(pchan->DmaCmdPoolMask);
			BIT_UNSET(pchan->DmaCmdPoolMask, cmd_tag);
			pchan->free_cmd--;
			pchan->submit_cmd++;
			spin_unlock(&pchan->lock);

#ifdef DEBUG_DMA
			pr_debug("task let pchan %d free cmd %d, submit cmd %d, pool mask %llx...\n",
				pchan->idx, pchan->free_cmd, pchan->submit_cmd, pchan->DmaCmdPoolMask);
#endif
			*ppchan = pchan;
			break;
		}
	}

	return cmd_tag;
}

static inline void SubmitDMACommand(VDMA_B0_CmdCfg_T *pVdmaCfg, struct xdx_vchan *vchan, struct xdx_desc *txd)
{
	struct xdx_dma_dev *sdev = to_xdx_dma_dev(vchan->vc.chan.device);
	struct xdx_pchan *pchan = NULL;
	VDMA_B0_CmdData_T VdmaCmd;
	uint32_t cmd_tag;

	//Get_freeCommand
	cmd_tag = xdx_dma_get_command_tag(sdev, &pchan);
	DBG_ASSERT(pchan);
	pchan->cmdRef[cmd_tag].desc = txd; //record command reference in pchan struct
	pchan->cmdRef[cmd_tag].vchan = vchan; //record command reference in pchan struct
	pVdmaCfg->CommandTag = cmd_tag;

	VDMA_B0_GenVdmaCmd(pVdmaCfg, &VdmaCmd);
	//VDMA_B0_DumpVdmaCmd(&VdmaCmd);

#ifdef DEBUG_VDMA
	VDMA_DRV_DumpVdmaCmdCfg(pVdmaCfg);
	VDMA_DRV_DumpVdmaCmdData(&VdmaCmd);
#endif

	spin_lock(&pchan->lock);
	VDMA_B0_WrCmdBuf((IMG_UINT64)pchan->base, VdmaCmd.cmd64, 3);

	spin_unlock(&pchan->lock);
}

static inline void SubmitTDMACommand(TDMA_CmdCfg_T *pTdmaCfg, struct xdx_vchan *vchan, struct xdx_desc *txd)
{
	struct xdx_dma_dev *sdev = to_xdx_dma_dev(vchan->vc.chan.device);
	struct xdx_pchan *pchan = NULL;
	TDMA_CmdData_T TdmaCmd;
	uint32_t cmd_tag;
	//Get_freeCommand
	cmd_tag = xdx_Tdma_get_command_tag(sdev, &pchan);
	DBG_ASSERT(pchan);
	pchan->cmdRef[cmd_tag].desc = txd; //record command reference in pchan struct
	pchan->cmdRef[cmd_tag].vchan = vchan; //record command reference in pchan struct
	pTdmaCfg->Tag = cmd_tag;
	TDMA_GenCmd(pTdmaCfg, &TdmaCmd);
	TDMA_DumpCmd(&TdmaCmd);
#ifdef DEBUG_VDMA
//	VDMA_DRV_DumpVdmaCmdCfg(pVdmaCfg);
//	VDMA_DRV_DumpVdmaCmdData(&VdmaCmd);
#endif

	spin_lock(&pchan->lock);
	TDMA_WrCmdBuf((uint64_t)xdxTdma_regsbase, TdmaCmd.cmd64, 4);
	spin_unlock(&pchan->lock);
}


static void PackageNodeCommand(struct xdx_desc *txd, struct xdx_vchan *vchan, dma_addr_t host_addr, dma_addr_t dev_addr, uint32_t aligned_size)
{
	VDMA_B0_CmdCfg_T VdmaCfg;

	memset(&VdmaCfg, 0, sizeof(VDMA_B0_CmdCfg_T));

	VdmaCfg.IntrEn = 1;
	VdmaCfg.OpCode = VDMA_B0_OPCODE_COPY_DSRC_DDST;
#if defined(SUPPORT_DONT_SNOOP) || defined(__arm64__) || defined(__aarch64__)
	VdmaCfg.PcieDontSnoop = 1;
#endif

	if(txd->direct == DMA_MEM_TO_DEV) //MEM2DEV
	{
		VdmaCfg.copy.DstAddr = dev_addr;
		VdmaCfg.copy.DstAddrMode  = PACK_ADDRMODE(VDMA_B0_ADDRMODE_GPU_PA, VDMA_B0_ADDRMODE_GPU_PA);

		VdmaCfg.copy.SrcAddr = host_addr;
		VdmaCfg.copy.SrcAddrMode =  PACK_ADDRMODE(VDMA_DRV_ADDRMODE_HOST_SVA, VDMA_DRV_ADDRMODE_HOST_SVA);
//		PackageDMACfg(&VdmaCfg, txd->dev_addr + txd->transfer_len, tail_addr, VDMA_DRV_ADDRMODE_GPU_SVA, VDMA_DRV_ADDRMODE_HOST_SVA);
	}
	else //DEV2MEM
	{
		VdmaCfg.copy.SrcAddr = dev_addr;
		VdmaCfg.copy.SrcAddrMode =  PACK_ADDRMODE(VDMA_B0_ADDRMODE_GPU_PA, VDMA_B0_ADDRMODE_GPU_PA);

		VdmaCfg.copy.DstAddr = host_addr;
		VdmaCfg.copy.DstAddrMode = PACK_ADDRMODE(VDMA_DRV_ADDRMODE_HOST_SVA, VDMA_DRV_ADDRMODE_HOST_SVA);
//		PackageDMACfg(&VdmaCfg, tail_addr, txd->dev_addr + txd->transfer_len, VDMA_DRV_ADDRMODE_HOST_SVA, VDMA_DRV_ADDRMODE_GPU_SVA);
	}

//	VdmaCfg.CopyParam.LengthUnit = VDMA_DRV_LENUNIT_8B;
//	VdmaCfg.CopyParam.TransferLen = (aligned_size >> VDMA_DRV_LENUNIT_8B_SHIFT);

	VdmaCfg.copy.LenUnit = VDMA_B0_LENUNIT_8B;
	VdmaCfg.copy.TransferLen = (aligned_size >> VDMA_DRV_LENUNIT_8B_SHIFT);

	OSAtomicIncrement((atomic_t *)&txd->Cmd_cnt);
	SubmitDMACommand(&VdmaCfg, vchan, txd);
}


static void TrimDirectNode(struct xdx_desc *txd, struct xdx_vchan *vchan)
{
	uint32_t aligned_size;

	if((txd->transfer_len > VDMA_MAX_SIZE_8B) && (0 == txd->linklist_len))
	{
		aligned_size = MOD_2(txd->transfer_len, VDMA_ADDR_BEST_ALIGN);
		//pr_debug("txd->transfer_len = 0x%x aligned_size = 0x%x\n",txd->transfer_len, aligned_size);
		if(aligned_size)
		{
			PackageNodeCommand(txd, vchan, txd->host_addr, txd->dev_addr, aligned_size);

			txd->transfer_len -= aligned_size;
			txd->dev_addr += aligned_size;
			txd->host_addr += aligned_size;
		}
	}
}

static void SendNormalNode(struct xdx_desc *txd, struct xdx_vchan *vchan)
{
//	struct xdx_dma_dev *sdev = to_xdx_dma_dev(vchan->vc.chan.device);
	VDMA_B0_CmdCfg_T VdmaCfg;
	TDMA_CmdCfg_T TdmaCfg;

	memset(&VdmaCfg, 0, sizeof(VDMA_B0_CmdCfg_T));

	//VdmaCfg.CommandTag = 0;
	VdmaCfg.IntrEn = 1;
#if defined(SUPPORT_DONT_SNOOP) || defined(__arm64__) || defined(__aarch64__)
	VdmaCfg.PcieDontSnoop = 1;
#endif
	if (txd->v_lli) {
		//use linklist

		if (txd->direct == DMA_MEM_TO_DEV) { //MEM2DEV
			VdmaCfg.copy.SrcDescNum = txd->linklist_len;
			//VdmaCfg.copy.DstDescNum = 0;
			VdmaCfg.OpCode = VDMA_B0_OPCODE_COPY_LSRC_DDST;

			VdmaCfg.copy.DstAddr = txd->dev_addr;
			VdmaCfg.copy.DstAddrMode  = PACK_ADDRMODE(VDMA_B0_ADDRMODE_GPU_PA, VDMA_B0_ADDRMODE_GPU_PA);

			VdmaCfg.copy.SrcAddr = txd->p_lli;
			VdmaCfg.copy.SrcAddrMode =  PACK_ADDRMODE(VDMA_DRV_ADDRMODE_HOST_SVA, VDMA_DRV_ADDRMODE_HOST_SVA);
		} else {
			//VdmaCfg.copy.SrcDescNum = 0;
			VdmaCfg.copy.DstDescNum = txd->linklist_len;
			VdmaCfg.OpCode = VDMA_B0_OPCODE_COPY_DSRC_LDST;
			VdmaCfg.copy.SrcAddr = txd->dev_addr;
			VdmaCfg.copy.SrcAddrMode =  PACK_ADDRMODE(VDMA_B0_ADDRMODE_GPU_PA, VDMA_B0_ADDRMODE_GPU_PA);
			VdmaCfg.copy.DstAddr = txd->p_lli;
			VdmaCfg.copy.DstAddrMode = PACK_ADDRMODE(VDMA_DRV_ADDRMODE_HOST_SVA, VDMA_DRV_ADDRMODE_HOST_SVA);
		}

		if (txd->transfer_len < VDMA_MAX_SIZE_8B) {
			DBG_ASSERT(TEST_ALIGNED(txd->transfer_len, VDMA_DRV_CMD_COPY_ADDR_ALIGN));	// Linklist data use 32Byte Align
			VdmaCfg.copy.LenUnit = VDMA_B0_LENUNIT_8B;
			VdmaCfg.copy.TransferLen = (txd->transfer_len >> VDMA_DRV_LENUNIT_8B_SHIFT);
		} else {
			DBG_ASSERT(TEST_ALIGNED(txd->transfer_len, VDMA_ADDR_BEST_ALIGN));	// Linklist data use 32Byte Align
			VdmaCfg.copy.LenUnit = VDMA_B0_LENUNIT_1K;
			VdmaCfg.copy.TransferLen = (txd->transfer_len >> VDMA_DRV_LENUNIT_1K_SHIFT);
		}

#if defined(SUPPORT_DONT_SNOOP) || defined(__arm64__) || defined(__aarch64__)
		{
			struct xdx_dma_lli *v_lli;
			 IMG_CPU_PHYADDR addr = {0};
			for (v_lli = txd->v_lli; v_lli; v_lli = v_lli->v_lli_next)
			{
				OSCPUCacheFlushRangeKM(NULL,
						(IMG_BYTE*)&(v_lli->xdma_desc[0]),
						(IMG_BYTE*)&(v_lli->xdma_desc[v_lli->desc_num]),
						addr, addr);
			}
		}
#endif
		//pr_err("send linklist transfer_len = %x, link len %d, txd->p_lli %llx\n",txd->transfer_len, txd->linklist_len, txd->p_lli);
	} else {
		//use direct
		if (txd->CopyType == COPY_1D) {
			VdmaCfg.OpCode = VDMA_B0_OPCODE_COPY_DSRC_DDST;
			//VdmaCfg.copy.SrcDescNum = 0;
			//VdmaCfg.copy.DstDescNum = 0;
			if(txd->direct == DMA_MEM_TO_DEV) //MEM2DEV
			{
				VdmaCfg.copy.DstAddr = txd->dev_addr;
				VdmaCfg.copy.DstAddrMode  = PACK_ADDRMODE(VDMA_B0_ADDRMODE_GPU_PA, VDMA_B0_ADDRMODE_GPU_PA);

				VdmaCfg.copy.SrcAddr = txd->host_addr;
				VdmaCfg.copy.SrcAddrMode =  PACK_ADDRMODE(VDMA_DRV_ADDRMODE_HOST_SVA, VDMA_DRV_ADDRMODE_HOST_SVA);
			} else { //DEV2MEM
				VdmaCfg.copy.SrcAddr = txd->dev_addr;
				VdmaCfg.copy.SrcAddrMode =  PACK_ADDRMODE(VDMA_B0_ADDRMODE_GPU_PA, VDMA_B0_ADDRMODE_GPU_PA);
				VdmaCfg.copy.DstAddr = txd->host_addr;
				VdmaCfg.copy.DstAddrMode = PACK_ADDRMODE(VDMA_DRV_ADDRMODE_HOST_SVA, VDMA_DRV_ADDRMODE_HOST_SVA);
			}
			if (txd->transfer_len < VDMA_MAX_SIZE_8B) {
				DBG_ASSERT(TEST_ALIGNED(txd->transfer_len, VDMA_DRV_CMD_COPY_ADDR_ALIGN));	// Linklist data use 32Byte Align
				VdmaCfg.copy.LenUnit = VDMA_B0_LENUNIT_8B;
				VdmaCfg.copy.TransferLen = (txd->transfer_len >> VDMA_DRV_LENUNIT_8B_SHIFT);
			} else {
				DBG_ASSERT(TEST_ALIGNED(txd->transfer_len, VDMA_ADDR_BEST_ALIGN));	// Linklist data use 32Byte Align
				VdmaCfg.copy.LenUnit = VDMA_B0_LENUNIT_1K;
				VdmaCfg.copy.TransferLen = (txd->transfer_len >> VDMA_DRV_LENUNIT_1K_SHIFT);
			}
		} else if (txd->CopyType == COPY_2D) {
			VdmaCfg.OpCode = VDMA_B0_OPCODE_2DCOPY;
			pr_info("txd->Dma_interleav_info.width = %llx\n",txd->Dma_interleav_info.width);
			VdmaCfg.copy2d.SrcAddr = txd->Dma_interleav_info.Start_addr;
			VdmaCfg.copy2d.DstAddr = txd->Dma_interleav_info.Dst_addr;
//			if (txd->Dma_interleav_info.width*txd->Dma_interleav_info.height < VDMA_2D_512K )
			{
				VdmaCfg.copy2d.LenUnit = VDMA_B0_LENUNIT_8B;
				VdmaCfg.copy2d.Sstride = txd->Dma_interleav_info.Srcstride/8;
				VdmaCfg.copy2d.Dstride = txd->Dma_interleav_info.Dststride/8;
				VdmaCfg.copy2d.Xstep = txd->Dma_interleav_info.width/8;
			}
			VdmaCfg.copy2d.Ystep = txd->Dma_interleav_info.height;
			if (txd->direct == DMA_MEM_TO_DEV) {
				VdmaCfg.copy2d.SrcAddrMode = PACK_ADDRMODE(VDMA_DRV_ADDRMODE_HOST_SVA, VDMA_DRV_ADDRMODE_HOST_SVA);;
				VdmaCfg.copy2d.DstAddrMode = PACK_ADDRMODE(VDMA_B0_ADDRMODE_GPU_PA, VDMA_B0_ADDRMODE_GPU_PA);
			}
			else if(txd->direct == DMA_DEV_TO_MEM)
			{
				VdmaCfg.copy2d.SrcAddrMode = PACK_ADDRMODE(VDMA_B0_ADDRMODE_GPU_PA, VDMA_B0_ADDRMODE_GPU_PA);;
				VdmaCfg.copy2d.DstAddrMode = PACK_ADDRMODE(VDMA_DRV_ADDRMODE_HOST_SVA, VDMA_DRV_ADDRMODE_HOST_SVA);
			}
			else
			{
				VdmaCfg.copy2d.SrcAddrMode = PACK_ADDRMODE(VDMA_B0_ADDRMODE_GPU_PA, VDMA_B0_ADDRMODE_GPU_PA);
				VdmaCfg.copy2d.DstAddrMode = PACK_ADDRMODE(VDMA_B0_ADDRMODE_GPU_PA, VDMA_B0_ADDRMODE_GPU_PA);
			}
			//pr_err("SrcAddrMode = 0x%x DstAddrMode = 0x%x\n",VdmaCfg.copy2d.SrcAddrMode,VdmaCfg.copy2d.DstAddrMode);
			//VdmaCfg.copy2d.LogicOp = VDMA_B0_LOGICOP_NONE;
		}
		#if 1
		else if (txd->CopyType == COPY_TDMA) {
			TdmaCfg.SrcAddr = txd->Dma_interleav_info.Start_addr;
			TdmaCfg.DstAddr = txd->Dma_interleav_info.Dst_addr;
			TdmaCfg.Xstep = txd->Dma_interleav_info.width;
			TdmaCfg.Ystep = txd->Dma_interleav_info.height;
			TdmaCfg.Zstep = txd->Dma_interleav_info.depth;
			TdmaCfg.Xstride = txd->Dma_interleav_info.Srcstride;
			TdmaCfg.Ystride = txd->Dma_interleav_info.Dststride;
			TdmaCfg.IntrEn = 1;
			TdmaCfg.LenUnit = txd->Dma_interleav_info.LenUnit;
			TdmaCfg.Tag = 0;
			TdmaCfg.DontSnoop = 0;
		//	if (TdmaCfg.Ystride == TdmaCfg.Xstride)
			if (txd->Dma_interleav_info.depth == 1)
			{
				TdmaCfg.Opcode = TDMA_OPCODE_2DCOPY;
			}
			else
			{
				TdmaCfg.Opcode = TDMA_OPCODE_3DCOPY;
			}

			if (txd->direct == DMA_MEM_TO_DEV)
			{
				TdmaCfg.SrcAddrMode = TDMA_SRCADDRMODE_HOST_VA;
				TdmaCfg.DstAddrMode = TDMA_DSTADDRMODE_GPU_PA;
			}
			else  //(txd->direct == DMA_DEV_TO_DEV)
			{
				TdmaCfg.SrcAddrMode = TDMA_SRCADDRMODE_GPU_PA;
				TdmaCfg.DstAddrMode = TDMA_DSTADDRMODE_GPU_PA;
			//	VdmaCmd[i] = xdx_dma_B0_DirectToDirect(v_lli->src+tmp_len,v_lli->dst,v_lli->len,dir,i);
			}

		}
		#endif
	}

	if (txd->CopyType == COPY_TDMA) {
		SubmitTDMACommand(&TdmaCfg, vchan, txd);
	} else {
		SubmitDMACommand(&VdmaCfg, vchan, txd);
	}
}

struct dma_async_tx_descriptor *xdx_dma_prep_dma_2Dcopy(
		struct dma_chan *chan,
		IMG_UINT64* src_addr,
		IMG_UINT64  dst_addr,
		int width,
		int height,
		int src_stride,
		int dst_stride,
		enum dma_transfer_direction dir,
		unsigned long flags)
{
	struct xdx_dma_dev *sdev = to_xdx_dma_dev(chan->device);
	struct xdx_vchan *vchan = to_xdx_vchan(chan);
	struct xdx_desc *txd;

	if (!width  && height)
		return NULL;
	txd = kmem_cache_alloc(sdev->txpool, GFP_NOWAIT);
	if (!txd)
		return NULL;
	memset(txd, 0x00, sizeof(struct xdx_desc));
	txd->CopyType = COPY_2D;

	txd->direct = dir;
	txd->Dma_interleav_info.Start_addr = (IMG_UINT64)src_addr;
	txd->Dma_interleav_info.Dst_addr = (IMG_UINT64)dst_addr;
	txd->Dma_interleav_info.width = width;
	txd->Dma_interleav_info.height = height;
	txd->Dma_interleav_info.Srcstride = src_stride;
	txd->Dma_interleav_info.Dststride = dst_stride;
	txd->transfer_len = width * height;
	txd->Cmd_cnt.counter++;

	pr_info("width = %d height = %d\n",width,height);
	return xdx_vchan_tx_prep(&vchan->vc, &txd->vd, flags);

}
EXPORT_SYMBOL_GPL(xdx_dma_prep_dma_2Dcopy);


static inline int GetFreeTotalCommand(struct xdx_dma_dev *sdev)
{
	uint32_t i, nTotalFree = 0;
	struct xdx_pchan *pchan;

	for(i = 0; i < sdev->num_pchans; i++) {
		pchan = &(sdev->pchans[i]);
		nTotalFree += pchan->free_cmd;
	}
	return nTotalFree;
}


//send Tail dma command
static void xdx_dma_package_sgl(struct xdx_desc *txd,
		struct xdx_dma_dev *sdev,
		struct xdx_vchan *vchan)
{
	struct xdx_dma_lli *v_lli = NULL, *v_next = NULL;
	dma_addr_t p_lli;
	//VDMA_B0_DescData_T *pVdmaDesc;
	uint32_t TransferLen;
	dma_addr_t tail_addr;

	//pr_err("txd = 0x%llx sdev->txpool = 0x%llx\n",(uint64_t)txd,(uint64_t)sdev->txpool);
	//pr_err("%s line:%d\n",__func__,__LINE__);
	//pr_err("sg_len = %d\n",sg_len);
	//pr_err("txd send sgl len %d\n", txd->sg_len);
	if(txd->sgl)
	{
		struct scatterlist *sg;
		int i;

		for_each_sg(txd->sgl, sg, txd->sg_len, i)
		{
			if(NULL == v_lli)
			{
				//allocate one page contig non-coherent memory(cachable)
				v_lli = alloc_lli(&p_lli);
				if (!v_lli)
				{
					pr_err("can't allocate dma memory!!\n");
					DBG_ASSERT(0);
				}

				v_lli->desc_num = 0;
				v_lli->desc_total = (PAGE_SIZE - offsetof(struct xdx_dma_lli, xdma_desc))/sizeof(VDMA_B0_DescData_T);

				pr_debug("allocate v_lli desc total %d, phy addr %llx, v_lli %llx\n", v_lli->desc_total, p_lli, (uint64_t)v_lli);
			}

			TransferLen = sg_dma_len(sg);
			tail_addr = sg_dma_address(sg);

			if(txd->transfer_len <= VDMA_MAX_SIZE_8B)
			{
				//package sgl desc
				VDMA_B0_GenNonEndVdmaDesc(tail_addr, (TransferLen >> VDMA_DRV_LENUNIT_8B_SHIFT), VDMA_B0_LENUNIT_8B, &(v_lli->xdma_desc[v_lli->desc_num]));
				v_lli->desc_num++;
				if(v_lli->desc_num >= (v_lli->desc_total - 1))
				{
					v_next = xdx_dma_lli_add(v_next, v_lli, p_lli, txd);
					v_lli = NULL;
				}
			}
			else
			{
				IMG_UINT32 aligned_size = MOD_2(TransferLen, VDMA_ADDR_BEST_ALIGN);

				if(aligned_size)
				{
					TransferLen -= aligned_size;
					txd->transfer_len -= aligned_size;

					if(0 == i)
					{
						//send head dma command
						PackageNodeCommand(txd, vchan, txd->host_addr, txd->dev_addr, aligned_size);

						txd->dev_addr += aligned_size;
						txd->host_addr += aligned_size;
						tail_addr += aligned_size;
					}
					else
					{
						DBG_ASSERT(i + 1 >= txd->sg_len);

						//send Tail dma command
						PackageNodeCommand(txd, vchan, tail_addr + TransferLen, txd->dev_addr + txd->transfer_len, aligned_size);
					}
				}

				if(TransferLen)
				{
					DBG_ASSERT(0 == MOD_2(TransferLen, VDMA_ADDR_BEST_ALIGN));
					VDMA_B0_GenNonEndVdmaDesc(tail_addr, (TransferLen >> VDMA_DRV_LENUNIT_1K_SHIFT), VDMA_B0_LENUNIT_1K, &(v_lli->xdma_desc[v_lli->desc_num]));
					v_lli->desc_num++;

					if(v_lli->desc_num >= (v_lli->desc_total - 1))
					{
						v_next = xdx_dma_lli_add(v_next, v_lli, p_lli, txd);
						v_lli = NULL;
					}
				}
			}
		}

		if(v_lli) {
			if(v_lli->desc_num > 0) {
				v_next = xdx_dma_lli_add(v_next, v_lli, p_lli, txd);
				//pr_debug("linklist_len %d, sgl_len %d, DESC num %d\n", txd->linklist_len, txd->sg_len, v_lli->desc_num);
			} else {
				free_lli(v_lli, p_lli);
			}
		}
	}
	else
	{
		DBG_ASSERT(0 == txd->linklist_len);
		//pr_err("linklist_len %d, sgl %llx, sgl_len %d\n", txd->linklist_len, (uint64_t)txd->sgl, txd->sg_len);
		TrimDirectNode(txd, vchan);
	}

	//here, we need consider align to 8 Bytes and all in on IOMMU
	return;
}

static int xdx_dma_start_desc(struct xdx_dma_dev *sdev, struct xdx_vchan *vchan)
{
	struct xdx_virt_dma_desc *desc;
	struct xdx_desc	*txd;
	uint32_t nFreeCmd;
	struct xdx_pchan *pchan;
	int iRet = -EAGAIN;

	do {
		desc = xdx_vchan_next_desc(&vchan->vc);
		if (!desc) {
			break;
		}

		txd = to_xdx_desc(&desc->tx);
		nFreeCmd = GetFreeTotalCommand(sdev);

		if (txd->Cmd_cnt.counter > nFreeCmd) {
			pr_info("free command %d less than %d\n", nFreeCmd, txd->Cmd_cnt.counter);
			iRet = 0;
			break;
		}

		list_del(&desc->node);
		txd->dev_addr = desc->tx.phys;

		if (txd->Cmd_cnt.counter > 1) {
			txd->Cmd_cnt.counter = 1;
			xdx_dma_package_sgl(txd, sdev, vchan);
		}

		if (txd->transfer_len) {
			SendNormalNode(txd, vchan);
		}
		pchan = &sdev->pchans[0];

#if defined(DEBUG_VDMA)
//		VDMA_DRV_CH_Monitor(0xffff0002);
#endif
	}while(1);

#ifdef NOHW_DEBUG
		pr_debug("xdx_dma_start_desc done ...\n");
		sdev->timer.expires = jiffies + 1*HZ;
		timer_setup(&sdev->timer,timer_handler,0);
		add_timer(&sdev->timer);
#endif
	return iRet;
}

static void xdx_dma_tasklet(unsigned long data)
{
	struct xdx_dma_dev *sdev = (struct xdx_dma_dev *)data;
	struct xdx_vchan *vchan;
	unsigned int vchan_idx, vcMask = sdev->pendingMask;
	unsigned long flags;

	while(vcMask) {
		vchan_idx = GetLeadOnefromU32(vcMask);
		BIT_UNSET(vcMask, vchan_idx);
		vchan = &sdev->vchans[vchan_idx];

		spin_lock_irqsave(&vchan->vc.lock, flags);
		if (0 == xdx_dma_start_desc(sdev, vchan)) {
			pr_info("xdx_dma_tasklet ... vc %d is full!!!\n", vchan->tag);
		}
		spin_unlock_irqrestore(&vchan->vc.lock, flags);
	}
}

int xdx_dma_chans_irq_set(struct xdx_dma_dev *sdev, unsigned int enable)
{
	struct xdx_pchan *pchan;
	int i;

	for (i = 0; i < sdev->num_pchans; i++) {
		pchan = &sdev->pchans[i];
		VDMA_B0_EnDisChIntr((uint64_t)sdev->base, DMA_CHAN_NUM(pchan->idx), !!enable);
	}
	return 0;
}

/*interrupt handler will run in tasklet which inplemented by soft IRQ*/
int xdx_dma_interrupt(struct xdx_dma_dev *sdev)
{
	struct xdx_vchan *vchan;
	struct xdx_pchan *pchan;
	struct xdx_desc	*txd;
	uint32_t cmd_tag;
	uint64_t CmdCmplRawSts;
	int i;

	for (i = 0; i < sdev->num_pchans; i++) {
		pchan = &sdev->pchans[i];
		if (pchan->submit_cmd) {
			CmdCmplRawSts = VDMA_B0_CH_RdAndClrCmdCmplRawSts((uint64_t)pchan->base);
			while(CmdCmplRawSts) {
				cmd_tag = GetLeadOnefromU64(CmdCmplRawSts);
				BIT_UNSET(CmdCmplRawSts, cmd_tag);
				txd = pchan->cmdRef[cmd_tag].desc;
				vchan = pchan->cmdRef[cmd_tag].vchan;

				spin_lock(&pchan->lock);
				xdx_dma_release_command_tag(pchan, cmd_tag);
				spin_unlock(&pchan->lock);

				if (atomic_dec_and_test(&txd->Cmd_cnt)) {
#if defined(DEBUG_VDMA)
//					VDMA_DRV_CH_Monitor(0xffff0009);
#endif
					spin_lock(&vchan->vc.lock);
					xdx_vchan_cookie_complete(&txd->vd);
					spin_unlock(&vchan->vc.lock);
				}
			}
		}

		if (!atomic_read(&sdev->tasklet_shutdown) && (sdev->pendingMask)) {
			tasklet_schedule(&sdev->task);
		}
	}
	return 0;
}

int xdx_tdma_interrupt(struct xdx_dma_dev *sdev)
{
//	struct xdx_dma_dev *sdev = platform_get_drvdata(dev_id);
	struct xdx_vchan *vchan;
	struct xdx_pchan *pchan;
	struct xdx_desc	*txd;
	uint32_t cmd_tag;
	uint64_t CmdCmplRawSts;
	uint64_t tdmaBaseAddr = (uint64_t)xdxTdma_regsbase;
	void __iomem *Tdma_Int_regs;
	IMG_UINT32 hostmisc_val;

	Tdma_Int_regs = hostmisc_regsbase+4;
	hostmisc_val = *(IMG_UINT32 *)Tdma_Int_regs;
	hostmisc_val &= ~TDMA_INT_ENABLE_MASK;
	*(IMG_UINT32 *)Tdma_Int_regs = hostmisc_val;

	pchan = &sdev->pchans[0];
	if (pchan->submit_cmd) {
		CmdCmplRawSts = TDMA_RdCmdCmplRawSts(tdmaBaseAddr);
		TDMA_WrCmdCmplClrReg(tdmaBaseAddr, CmdCmplRawSts);
		while(CmdCmplRawSts) {
			cmd_tag = GetLeadOnefromU64(CmdCmplRawSts);
			BIT_UNSET(CmdCmplRawSts, cmd_tag);
			txd = pchan->cmdRef[cmd_tag].desc;
			vchan = pchan->cmdRef[cmd_tag].vchan;
			spin_lock(&pchan->lock);
			xdx_dma_release_command_tag(pchan, cmd_tag);
			spin_unlock(&pchan->lock);
			DBG_ASSERT(txd->Cmd_cnt.counter);
			OSAtomicDecrement((atomic_t *)&txd->Cmd_cnt);
			if (0 == txd->Cmd_cnt.counter) {
				spin_lock(&vchan->vc.lock);
				xdx_vchan_cookie_complete(&txd->vd);
				spin_unlock(&vchan->vc.lock);
			}
		}
	}

	if (!atomic_read(&sdev->tasklet_shutdown) && (sdev->pendingMask)) {
		tasklet_schedule(&sdev->task);
	}
	hostmisc_val |= TDMA_INT_ENABLE_MASK;
	*(IMG_UINT32 *)Tdma_Int_regs = hostmisc_val;
	return 0;
}

static inline s8 convert_burst(u32 maxburst)
{
	switch (maxburst) {
	case 1:
		return 0;
	case 4:
		return 1;
	case 8:
		return 2;
	case 16:
		return 3;
	default:
		return -EINVAL;
	}
}


static inline s8 convert_buswidth(enum dma_slave_buswidth addr_width)
{
	return ilog2(addr_width);
}

static struct dma_async_tx_descriptor *xdx_dma_prep_dma_memcpy(
		struct dma_chan *chan, dma_addr_t dest, dma_addr_t src,
		size_t len, unsigned long flags)
{
	return NULL;

}

static struct dma_async_tx_descriptor *xdx_dma_prep_slave_sg(
		struct dma_chan *chan, struct scatterlist *sgl,
		unsigned int sg_len, enum dma_transfer_direction dir,
		unsigned long flags, void *context)
{
	struct xdx_dma_dev *sdev = to_xdx_dma_dev(chan->device);
	struct xdx_vchan *vchan = to_xdx_vchan(chan);
	struct xdx_desc *txd;
	uint32_t align_size;

	if (!sgl)
		return NULL;

	txd = kmem_cache_alloc(sdev->txpool, GFP_NOWAIT);
	if (!txd)
		return NULL;
	memset(txd, 0x00, sizeof(struct xdx_desc));
	txd->host_addr = sg_dma_address(sgl);
	if (sg_len > 1) {
		struct scatterlist *sg;
		int i;

		for_each_sg(sgl, sg, sg_len, i)
		{
			txd->transfer_len += sg_dma_len(sg); //accumulate transfer_len
		}

		txd->sgl = sgl;
		txd->sg_len = sg_len;
	}
	else
	{
		txd->transfer_len = sg_dma_len(sgl);
		DBG_ASSERT(0 == txd->linklist_len);
	}

	//here, we need consider align to 8 Bytes and all in on IOMMU
	align_size = MOD_2(txd->transfer_len, VDMA_ADDR_BEST_ALIGN);
	txd->Cmd_cnt.counter = (sg_len > 1) || ((txd->transfer_len > VDMA_MAX_SIZE_8B) && align_size) ? 3 : 1;
	txd->direct = dir;

#ifdef DEBUG_DMA
	dev_dbg(chan2dev(chan), "First link: %llx\n", txd->p_lli);
	for (v_next = txd->v_lli; v_next; v_next = v_next->v_lli_next) {
		xdx_dma_dump_lli(vchan, v_next);
	}
#endif
	return xdx_vchan_tx_prep(&vchan->vc, &txd->vd, flags);
}

static struct dma_async_tx_descriptor *xdx_dma_prep_slave_sg_iommu(
		struct dma_chan *chan, struct scatterlist *sgl,
		unsigned int sg_len, enum dma_transfer_direction dir,
		unsigned long flags, void *context)
{
	struct xdx_dma_dev *sdev = to_xdx_dma_dev(chan->device);
	struct xdx_vchan *vchan = to_xdx_vchan(chan);
	struct xdx_desc *txd;
	struct scatterlist *sg;
	int i;
	IMG_UINT32 align_size;

	if (!sgl)
		return NULL;

	//txd = kzalloc(sizeof(*txd), GFP_NOWAIT);
	txd = kmem_cache_alloc(sdev->txpool, GFP_KERNEL);
	if (!txd)
		return NULL;
	memset(txd, 0x00, sizeof(struct xdx_desc));
	//pr_err("%s line:%d ...\n",__func__,__LINE__);
	//txd->dev_addr = (dir == DMA_MEM_TO_DEV) ? sconfig->dst_addr : sconfig->src_addr;
	txd->host_addr = sg_dma_address(sgl);

	for_each_sg(sgl, sg, sg_len, i)
	{
		txd->transfer_len += sg_dma_len(sg); //accumulate transfer_len
	}

	txd->direct = dir;
	align_size = MOD_2(txd->transfer_len, VDMA_ADDR_BEST_ALIGN);
	pr_info("txd->transfer_len = %d align_size = %d\n",txd->transfer_len,align_size);
	txd->Cmd_cnt.counter = ((txd->transfer_len > VDMA_MAX_SIZE_8B) && align_size) ? 2 : 1;

	//lens = process_sgl(sdev,txd,dir);
	//pr_info("lens = %d\n");

	return xdx_vchan_tx_prep(&vchan->vc, &txd->vd, flags);
}

struct dma_async_tx_descriptor *xdx_Tdma_prep_memcpy(
		struct dma_chan *chan, void *interleav_info, unsigned long flags)
{
	struct xdx_dma_dev *sdev = to_xdx_dma_dev(chan->device);
	struct xdx_vchan *vchan = to_xdx_vchan(chan);
	struct xdx_desc *txd;
	DMA_INTERLEAV_B0_T *dma_interleav_info = (DMA_INTERLEAV_B0_T *)interleav_info;
	txd = kmem_cache_alloc(sdev->txpool, GFP_NOWAIT);
	if (!txd)
		return NULL;

	txd->Dma_interleav_info.Start_addr = (IMG_UINT64)dma_interleav_info->Start_addr;
	txd->Dma_interleav_info.Dst_addr = (IMG_UINT64)dma_interleav_info->Dst_addr;
	txd->Dma_interleav_info.width = dma_interleav_info->width;
	txd->Dma_interleav_info.height = dma_interleav_info->height;
	txd->Dma_interleav_info.Srcstride = dma_interleav_info->Srcstride;
	txd->Dma_interleav_info.Dststride = dma_interleav_info->Dststride;
	txd->Dma_interleav_info.LenUnit = dma_interleav_info->LenUnit;
	txd->Dma_interleav_info.depth = dma_interleav_info->depth;
	txd->transfer_len = txd->Dma_interleav_info.width*txd->Dma_interleav_info.height*txd->Dma_interleav_info.depth;
	txd->direct = flags;
	txd->CopyType = COPY_TDMA;
	txd->Cmd_cnt.counter++;

	return xdx_vchan_tx_prep(&vchan->vc, &txd->vd, flags);

}
EXPORT_SYMBOL_GPL(xdx_Tdma_prep_memcpy);


static int xdx_dma_config(struct dma_chan *chan,
			    struct dma_slave_config *config)
{
	//struct xdx_vchan *vchan = to_xdx_vchan(chan);
	//pr_info("xdx_dma_config ... \n");
	//memcpy(&vchan->cfg, config, sizeof(*config));
	return 0;
}

static int xdx_dma_pause(struct dma_chan *chan)
{
	struct xdx_dma_dev *sdev = to_xdx_dma_dev(chan->device);
	struct xdx_vchan *vchan = to_xdx_vchan(chan);

	dev_dbg(chan2dev(chan), "vchan %p: pause\n", &vchan->vc);
	{
		spin_lock_bh(&sdev->lock);
		BIT_UNSET(sdev->pendingMask, vchan->tag);
		spin_unlock_bh(&sdev->lock);
	}

	return 0;
}

static int xdx_dma_resume(struct dma_chan *chan)
{
	struct xdx_dma_dev *sdev = to_xdx_dma_dev(chan->device);
	struct xdx_vchan *vchan = to_xdx_vchan(chan);
	//struct xdx_pchan *pchan = vchan->phy;
	unsigned long flags;

	dev_dbg(chan2dev(chan), "vchan %p: resume\n", &vchan->vc);

	spin_lock_irqsave(&vchan->vc.lock, flags);
	if (!list_empty(&vchan->vc.desc_issued)) {
		spin_lock(&sdev->lock);
		BIT_SET(sdev->pendingMask, vchan->tag);
		//list_add_tail(&vchan->node, &sdev->pending);
		spin_unlock(&sdev->lock);
	}
	spin_unlock_irqrestore(&vchan->vc.lock, flags);

	return 0;
}

static int xdx_dma_terminate_all(struct dma_chan *chan)
{
	struct xdx_dma_dev *sdev = to_xdx_dma_dev(chan->device);
	struct xdx_vchan *vchan = to_xdx_vchan(chan);
	//struct xdx_pchan *pchan = vchan->phy;
	unsigned long flags;
	LIST_HEAD(head);

	spin_lock_bh(&sdev->lock);
	//list_del_init(&vchan->node);
	BIT_UNSET(sdev->pendingMask, vchan->tag);
	spin_unlock_bh(&sdev->lock);

	spin_lock_irqsave(&vchan->vc.lock, flags);
	if (vchan->cyclic) {
		vchan->cyclic = false;
	}
	xdx_vchan_get_all_descriptors(&vchan->vc, &head);
	spin_unlock_irqrestore(&vchan->vc.lock, flags);
	xdx_vchan_dma_desc_free_list(&vchan->vc, &head);
	return 0;
}


static enum dma_status xdx_dma_tx_status(struct dma_chan *chan,
		dma_cookie_t cookie,
		struct dma_tx_state *state)
{
	struct xdx_vchan *vchan = to_xdx_vchan(chan);
	struct xdx_virt_dma_desc *vd;
	struct xdx_desc *txd;
	enum dma_status ret;
	unsigned long flags;
	size_t bytes = 0;

	ret = dma_cookie_status(chan, cookie, state);
	if (ret == DMA_COMPLETE || !state)
		return ret;

	spin_lock_irqsave(&vchan->vc.lock, flags);
	vd = xdx_vchan_find_desc(&vchan->vc, cookie);
	txd = to_xdx_desc(&vd->tx);
	if (vd) {
		bytes = txd->transfer_len;
	}
	spin_unlock_irqrestore(&vchan->vc.lock, flags);
	dma_set_residue(state, bytes);
	return ret;
}

static void xdx_dma_issue_pending(struct dma_chan *chan)
{
	struct xdx_dma_dev *sdev = to_xdx_dma_dev(chan->device);
	struct xdx_vchan *vchan = to_xdx_vchan(chan);
	unsigned long flags;

	spin_lock_irqsave(&vchan->vc.lock, flags);
	if (xdx_vchan_issue_pending(&vchan->vc))
	{
		spin_lock(&sdev->lock);
		if(!BIT_ISSET(sdev->pendingMask, vchan->tag))
		{
			BIT_SET(sdev->pendingMask, vchan->tag);
		}
		spin_unlock(&sdev->lock);
		tasklet_schedule(&sdev->task);
	} else {
		dev_dbg(chan2dev(chan), "vchan %p: nothing to issue\n",
			&vchan->vc);
	}

	spin_unlock_irqrestore(&vchan->vc.lock, flags);
}

static void xdx_dma_free_chan_resources(struct dma_chan *chan)
{
	struct xdx_dma_dev *sdev = to_xdx_dma_dev(chan->device);
	struct xdx_vchan *vchan = to_xdx_vchan(chan);
	//unsigned long flags;

	spin_lock_bh(&sdev->lock);
	//list_del_init(&vchan->node);
	BIT_UNSET(sdev->pendingMask, vchan->tag);
	spin_unlock_bh(&sdev->lock);

	xdx_vchan_free_chan_resources(&vchan->vc);
}

static inline void xdx_kill_tasklet(struct xdx_dma_dev *sdev)
{
	/* Prevent spurious interrupts from scheduling the tasklet */
	atomic_inc(&sdev->tasklet_shutdown);

	/* Make sure we won't have any further interrupts */
	/* Actually prevent the tasklet from being scheduled */
	tasklet_kill(&sdev->task);
}

static inline void xdx_dma_free(struct xdx_dma_dev *sdev)
{
	int i;

	for (i = 0; i < sdev->num_vchans; i++) {
		struct xdx_vchan *vchan = &sdev->vchans[i];

		list_del(&vchan->vc.chan.device_node);
		tasklet_kill(&vchan->vc.task);
	}
}

static bool xdx_dma_filter_fn(struct dma_chan *chan,void *param)
{
	pr_info("xdx_dma_filter_fn (%s) ...\n", (char *)param);
	return true;
}

static int xdx_dma_chans_bind(
	struct xdx_dma_dev *sdc,
	struct xdx_vchan *vchan,
	struct xdx_dma_vchan_cfg *vcfg
)
{
	int i, j;

	vchan->pchans = devm_kcalloc(sdc->slave.dev,
		vcfg->num_pchan, sizeof(struct xdx_pchan*), GFP_KERNEL);
	if (IS_ERR_OR_NULL( vchan->pchans))
		return -ENOMEM;
	memset(vchan->pchans, U32_MAX, vcfg->num_pchan * sizeof(struct xdx_pchan*));
	for (i = 0; i < vcfg->num_pchan; i++) {
		for (j = 0; j < sdc->num_pchans; j++) {
			if (sdc->pchans[j].idx == vcfg->pchans[i]) {
				vchan->pchans[i] = &sdc->pchans[j];
				break;
			}
		}
	}
	return 0;
}

static int xdx_dma_pchan_init(
	struct xdx_dma_dev *sdc,
	struct xdx_pchan *pchan,
	struct xdx_dma_pchan_cfg *pcfg)
{
	pchan->dev = sdc->dev;
	pchan->idx = pcfg->chan_id;
	pchan->base = sdc->base + VDMA_CHANNEL_REG_OFFSET +
		DMA_DMA_NUM(pchan->idx) * VDMA_ADDR_OFFSET
		+ DMA_CHAN_NUM(pchan->idx) * VDMA_CHANNEL_REG_SEC_SIZE;
	dev_dbg(sdc->dev, "pchan[%x]base[%pK] Add!.", pchan->idx, pchan->base);
	pchan->DmaCmdPoolMask = ~0x0UL;
	pchan->submit_cmd = 0;
	spin_lock_init(&pchan->lock);
	pchan->free_cmd = CMD_MAX;

//	VDMA_DRV_CH_InitToDefault(pchan->base, DMA_CHAN_NUM(pchan->idx));
//	VDMA_DRV_CH_Enable(pchan->base, DMA_CHAN_NUM(pchan->idx));
//	VDMA_DRV_CH_EnableIntr(pchan->base, DMA_CHAN_NUM(pchan->idx));
//	VDMA_DRV_CH_ClearCmdCmplSts(pchan->base, DMA_CHAN_NUM(pchan->idx), ~0x0UL);
//	VDMA_DRV_CH_ClearPollingTimeoutSts(pchan->base, DMA_CHAN_NUM(pchan->idx), ~0x0UL);
//	VDMA_DRV_CH_ClearBusErrSts(pchan->base, DMA_CHAN_NUM(pchan->idx), ~0x0UL);
	pchan->inited = 1;
	return 0;
}

struct xdx_dma_ops vdma_a0_ops = {
	.irq_handler = xdx_dma_a0_interrupt,
};

struct xdx_dma_ops vdma_b0_ops = {
	.irq_handler = xdx_dma_interrupt,
};

struct xdx_dma_ops tdma_b0_ops = {
	.irq_handler = xdx_tdma_interrupt,
};

static int xdx_dma_ops_init(struct xdx_dma_dev *sdc)
{
	if ((sdc->dcfg->flags & XDXDMA_A0_VDMA_MASK) == XDXDMA_A0_VDMA_MASK) {
		sdc->ops = &vdma_a0_ops;
		xdxdma_regsbase =  sdc->base;
	} else if ((sdc->dcfg->flags & XDXDMA_B0_VDMA_MASK) == XDXDMA_B0_VDMA_MASK) {
		sdc->ops = &vdma_b0_ops;
		xdxdma_regsbase =  sdc->base;
	} else if ((sdc->dcfg->flags & XDXDMA_B0_TDMA_MASK) == XDXDMA_B0_TDMA_MASK) {
		sdc->ops = &tdma_b0_ops;
		xdxTdma_regsbase = sdc->base;
	} else {
		dev_err(sdc->dev, "not support device type:%x", sdc->dcfg->flags & 0xf);
		sdc->ops = NULL;
		return -EINVAL;
	}
	return 0;
}

static IMG_BOOL Is_xdx_iommu_enable(struct platform_device *xdx_dev)
{
#if (LINUX_VERSION_CODE < KERNEL_VERSION(4, 20, 0))
	return 0;
#else
	const struct dma_map_ops *ops;
	ops = get_dma_ops(xdx_dev->dev.parent);
	if(ops == NULL) {
		pr_err("iommu disable .\n");
		return IMG_FALSE;
	} else {
		pr_err("iommu enable .\n");
		return IMG_TRUE;
	}
#endif
}

static int xdx_dma_slave_b0_init(struct platform_device *pdev, struct xdx_dma_dev *sdc)
{
	INIT_LIST_HEAD(&sdc->slave.channels);
	sdc->slave.device_free_chan_resources = xdx_dma_free_chan_resources;
	sdc->slave.device_tx_status = xdx_dma_tx_status;
	sdc->slave.device_issue_pending = xdx_dma_issue_pending;
	sdc->IommuEnable = Is_xdx_iommu_enable(pdev);

	if(sdc->IommuEnable)
	{
		sdc->slave.device_prep_slave_sg     = xdx_dma_prep_slave_sg_iommu;
	}
	else
	{
		sdc->slave.device_prep_slave_sg 	= xdx_dma_prep_slave_sg;
	}
	sdc->slave.device_prep_dma_memcpy = xdx_dma_prep_dma_memcpy;
	//sdc->slave.device_prep_dma_cyclic = xdx_dma_prep_dma_cyclic;
	sdc->slave.copy_align = DMAENGINE_ALIGN_4_BYTES;
	sdc->slave.device_config = xdx_dma_config;
	sdc->slave.device_pause = xdx_dma_pause;
	sdc->slave.device_resume = xdx_dma_resume;
	sdc->slave.device_terminate_all = xdx_dma_terminate_all;
	sdc->slave.directions = BIT(DMA_DEV_TO_MEM) | BIT(DMA_MEM_TO_DEV);
	sdc->slave.residue_granularity = DMA_RESIDUE_GRANULARITY_BURST;
	sdc->slave.dev = &pdev->dev;
	dev_dbg(&pdev->dev, "sdc->slave.dev = 0x%llx\n",(IMG_UINT64)sdc->slave.dev);
	tasklet_init(&sdc->task, xdx_dma_tasklet, (unsigned long)sdc);
	return 0;
}

static int xdx_dma_slave_init(struct platform_device *pdev, struct xdx_dma_dev *sdc)
{
	if ((sdc->dcfg->flags & XDXDMA_A0_VDMA_MASK) == XDXDMA_A0_VDMA_MASK) {
		xdx_dma_slave_a0_init(pdev, sdc);
	} else if ((sdc->dcfg->flags & XDXDMA_B0_VDMA_MASK) == XDXDMA_B0_VDMA_MASK) {
		xdx_dma_slave_b0_init(pdev, sdc);
	} else if ((sdc->dcfg->flags & XDXDMA_B0_TDMA_MASK) == XDXDMA_B0_TDMA_MASK) {
		xdx_dma_slave_b0_init(pdev, sdc);
	} else {
		return -EINVAL;
	}
	return 0;
}
static int xdx_vdma_vchan_b0_init(struct xdx_dma_dev *sdc, struct xdx_vchan *vchan)
{
	vchan->vc.desc_free = xdx_dma_free_desc;
	return  0;
}

static int xdx_dma_vchan_plat_init(struct xdx_dma_dev *sdc, struct xdx_vchan *vchan)
{
	if ((sdc->dcfg->flags & XDXDMA_A0_VDMA_MASK) == XDXDMA_A0_VDMA_MASK) {
		xdx_vdma_vchan_a0_init(sdc, vchan);
	} else if ((sdc->dcfg->flags & XDXDMA_B0_VDMA_MASK) == XDXDMA_B0_VDMA_MASK) {
		xdx_vdma_vchan_b0_init(sdc, vchan);
	} else if ((sdc->dcfg->flags & XDXDMA_B0_TDMA_MASK) == XDXDMA_B0_TDMA_MASK) {
		xdx_vdma_vchan_b0_init(sdc, vchan);
	} else {
		return -EINVAL;
	}
	return 0;
}

static int xdx_dma_probe(struct platform_device *pdev)
{
	struct xdx_dma_dev *sdc;
	int ret;
	struct resource *res;
	u32 i;
	const struct platform_device_id *pdev_id;
	void __iomem *reg_base;
	void __iomem *hostmisc_base;
	const struct xdx_dma_drv_cfg *dcfg;

	sdc = devm_kzalloc(&pdev->dev, sizeof(*sdc), GFP_KERNEL);
	if (!sdc)
		return -ENOMEM;

	dev_dbg(&pdev->dev, "dma init start ...\n");
	res = platform_get_resource_byname(pdev, IORESOURCE_MEM, "base");
	if (!res) {
		dev_err(&pdev->dev, "Get REG base resource faild.\n");
		return -EINVAL;
	}
	reg_base = devm_ioremap_resource(&pdev->dev, res);
	if (IS_ERR_OR_NULL(reg_base)) {
		dev_err(&pdev->dev, "base registers resource map error.%ld\n", PTR_ERR(reg_base));
		return PTR_ERR(reg_base);
	}
	res = platform_get_resource_byname(pdev, IORESOURCE_MEM, "hostmisc-base");
	if (res) {
		dev_dbg(&pdev->dev, "set hostmisc reg.");
		hostmisc_base = devm_ioremap_resource(&pdev->dev, res);
		if (IS_ERR_OR_NULL(hostmisc_base)) {
			dev_err(&pdev->dev, "hostmisc map error.%ld\n", PTR_ERR(hostmisc_base));
			return PTR_ERR(hostmisc_base);
		}
		hostmisc_regsbase = hostmisc_base;
	}
	pdev_id = platform_get_device_id(pdev);
	if (!pdev_id || !pdev_id->driver_data)
		return -EINVAL;
	dcfg =  (struct xdx_dma_drv_cfg *)pdev_id->driver_data;
	sdc->dcfg = dcfg;
	sdc->cmd_cfg = &xdx_dma_cmd_cfg[0];
	sdc->base = reg_base;
	sdc->dev = &pdev->dev;
	sdc->mcu_id = VDMA_HAL_COM_RdVdMcuId((uint64_t)reg_base);
	sdc->pdata = dev_get_platdata(&pdev->dev);
	dev_info(&pdev->dev, "dma maped addr:%pK mcu_id:%x\n", reg_base, sdc->mcu_id);
	res = platform_get_resource_byname(pdev, IORESOURCE_REG, "irq-cid");
	if (!res) {
		dev_err(&pdev->dev, "Get irq-cid faild.\n");
		return -EINVAL;
	}
	sdc->irq_cid = res->start;
	xdx_dma_ops_init(sdc);
	xdx_dma_irq_init(sdc);
	sdc->pool = dmam_pool_create(dev_name(&pdev->dev), &pdev->dev,
					sizeof(struct xdx_dma_lli), XDX_VDMA_ADDR_ALIGN, 0);
	if (!sdc->pool) {
		dev_err(&pdev->dev, "No memory for descriptors dma pool\n");
		return -ENOMEM;
	}
	sdc->txpool = kmem_cache_create("pvr-tx", sizeof(struct xdx_desc), 0, 0, NULL);
	if (!sdc->txpool)
	{
		dev_err(&pdev->dev, "mempool_create_slab_pool fail!\n");
		return -ENOMEM;
	}

	//INIT_LIST_HEAD(&sdc->pending);
	spin_lock_init(&sdc->lock);
	platform_set_drvdata(pdev, sdc);
	dma_set_mask_and_coherent(&pdev->dev, DMA_BIT_MASK(48));
	dma_cap_set(DMA_PRIVATE, sdc->slave.cap_mask);
	dma_cap_set(DMA_SLAVE, sdc->slave.cap_mask);
	sdc->slave.src_addr_widths = dcfg->src_addr_widths;
	sdc->slave.dst_addr_widths = dcfg->dst_addr_widths;
	xdx_dma_slave_init(pdev, sdc);

	sdc->dcfg->fn_map->devname = (const char *)dev_name(&pdev->dev);
	sdc->slave.filter.fn = xdx_dma_filter_fn;
	sdc->slave.filter.mapcnt = 1;
	sdc->slave.filter.map = sdc->dcfg->fn_map;
	dev_info(&pdev->dev, "xdx_dma_map.devname = %s\n", sdc->slave.filter.map->devname);

	sdc->num_pchans = dcfg->num_pchan;
	sdc->pchans = devm_kcalloc(&pdev->dev, sdc->num_pchans,
				sizeof(struct xdx_pchan), GFP_KERNEL);
	if (!sdc->pchans)
		return -ENOMEM;

	sdc->num_vchans = dcfg->num_vchan;
	sdc->vchans = devm_kcalloc(&pdev->dev, sdc->num_vchans,
				sizeof(struct xdx_vchan), GFP_KERNEL);
	if (!sdc->vchans)
		return -ENOMEM;
	for (i = 0; i < sdc->num_pchans; i++) {
		ret = xdx_dma_pchan_init(sdc, &sdc->pchans[i], &dcfg->pchans[i]);
		if (ret < 0)
			return ret;
	}

	for (i = 0; i < sdc->num_vchans; i++)
	{
		struct xdx_vchan *vchan = &sdc->vchans[i];
		vchan->tag = i; //vc index
		vchan->dev = &pdev->dev;
		xdx_dma_vchan_plat_init(sdc, vchan);
		xdx_vchan_init(&vchan->vc, &sdc->slave);
		ret = xdx_dma_chans_bind(sdc, vchan, &dcfg->vchans[i]);
		if (ret < 0)
			goto error_out;
	}
	ret = dma_async_device_register(&sdc->slave);
	if (ret) {
		dev_warn(&pdev->dev, "Failed to register DMA engine device\n");
		goto err_irq_disable;
	}

#ifdef GENERATE_LINKLIST
//	dma_hash = HASH_Create_Int(100);
#endif
	dev_dbg(&pdev->dev, "dma init done ...\n");
	return 0;
err_irq_disable:
	dma_async_device_unregister(&sdc->slave);
error_out:
	xdx_kill_tasklet(sdc);
	xdx_dma_free(sdc);
	return ret;
}

static int xdx_dma_remove(struct platform_device *pdev)
{
	struct xdx_dma_dev *sdc = platform_get_drvdata(pdev);
	dma_async_device_unregister(&sdc->slave);
	pr_debug("exit xdx_dma_remove ###\n");

	xdx_kill_tasklet(sdc);
	dmam_pool_destroy(sdc->pool);
	kmem_cache_destroy(sdc->txpool);
	xdx_dma_free(sdc);

#ifdef GENERATE_LINKLIST
//	HASH_Delete(dma_hash);
#endif
	pr_debug("exit xdx_dma_remove done !!!\n");
	return 0;
}

static struct platform_driver xdx_dma_driver = {
	.probe = xdx_dma_probe,
	.remove = xdx_dma_remove,
	.driver = {
		.name = "xdx-dma",
		.owner = THIS_MODULE,
	},
	.id_table = xdx_platform_device_id_table,
};

int xdx_dma_drv_init(void)
{
	int err;
	err = platform_driver_register(&xdx_dma_driver);
	if(err)
		return err;

	return 0;
}
//EXPORT_SYMBOL(xdx_dma_drv_init);

void xdx_dma_drv_exit(void)
{
	platform_driver_unregister(&xdx_dma_driver);
}
