#ifndef __XDX_FW_H__
#define __XDX_FW_H__

#include <linux/types.h>

struct xdx_device;

#define CMCU_VARS_OFFSET       0x6FF000   //7MB-4KB
#define CMCU_VARS_SIZE         0x1000     //4KB
#define SHARED_VARS_OFFSET     0x700000   //7MB
#define ACPU_TRACE_OFFSET      0x800000   //8MB
#define ACPU_TRACE_SIZE        0x400000   //4MB
#define CMCU_TRACE_OFFSET      0xC00000   //12MB
#define CMCU_TRACE_SIZE        0x200000   //2MB
#define VDMCU0_TRACE_OFFSET    0xE00000   //14MB
#define VDMCU0_TRACE_SIZE      0x100000   //1MB
#define VDMCU1_TRACE_OFFSET    0xF00000   //15MB
#define VDMCU1_TRACE_SIZE      0x100000   //1MB

#define PARAMETER_PAGE_OFFSET  0x58000   //256KB+96KB
#define PARAMETER_PAGE_SIZE    0x1000    //4KB

#define ACPU_VARS_OFFSET       0x59000   //256KB+96KB+4KB
#define ACPU_VARS_SIZE         0x5000    //20KB

/* cache fw static info in KMD */
struct xdx_fw_static_info {
	/* only cache KMD needed static info from FW shared memory */
	u32 default_gpu_freq;
	u32 bootup_gpu_freq;
	u32 acpu_freq;
	u32 cmcu_freq;
	u32 sys_freq;
	u32 ndf_freq;
	u32 fw_ver;
	u32 gddr_freq;
	u32 chip_id;
	u32 sku;
	u32 gpu_primary_id;
	u32 gpu_primary_core_id;
	u32 gddr_count;
	u32 pcie_event;
	char *pcie_mmbar_type;
	char *asci_type;
	char vbiosVerString[64];
	char gpu_core[4];
	u32 gddr_temp;
};

u32 update_gddr_temp(struct xdx_device *xdev);

int cache_fw_static_info(struct xdx_device *xdev);

#endif /* __XDX_FW_H__ */
