#ifndef __XDX_VPU_H__
#define __XDX_VPU_H__

#include <linux/list.h>
#include "xdx_shared.h"

struct xdx_vpu {
    struct xdx_ip_block base;
	struct xdx_irq_src *irq_src;
	struct work_struct vpuirq_dec_work;
	struct work_struct vpuirq_enc_work;
	struct workqueue_struct *vpu_workq;

	struct list_head vcmd_slice;

};

int xdx_vpu_isr_install(struct xdx_device *xdev);
int vpu_isr_uninstall(struct xdx_device *xdev);
int xdx_vpu_init(struct xdx_device *xdev);
int xdx_vpu_fini(struct xdx_device *xdev);

extern const struct xdx_ip_block_version vpu_ip_block_version;

#endif /* __XDX_VPU_H__ */
